<?

/*

VoxPopuli

Copyright (c) 2009-2010, EldoS Corporation

For licensing and distribution terms visit http://www.eldos.com/

*/

include_once("vox-config.php");

// ****************************************************************************
// MANDATORY FUNCTIONS
// ****************************************************************************

// IMPORTANT: implement this function to integrate VoxPopuli with your site
// This function returns numeric ID of the currently logged user
// 0 is returned when the user is not logged on
function vox_user_get_id()
{
	return 1;
}

// IMPORTANT: implement this function to integrate VoxPopuli with your site
// This function checks whether current user is an admin, and returns
// true or false
function vox_user_is_admin()
{
	return true;
}

// IMPORTANT: implement this function to integrate VoxPopuli with your site
// This function checks whether current user has permissions to perform certain operation
function vox_user_has_rights($categoryId, $operationId)
{
	return false;
}

// ****************************************************************************
// OPTIONAL FUNCTIONS
// ****************************************************************************

// This function returns the name of the user by it's ID
// Parameters: 
// 	userId - id of the user who submitted the idea
// Result:
//  (string) name of the user or empty string if the ID is not valid.
function vox_user_get_name_by_id($userId)
{
}

// This function returns the URL of the user contact information by it's ID
// Parameters: 
// 	userId - id of the user who submitted the idea
// Result:
//  (string) URL or empty string if the ID is not valid.
function vox_user_get_contact_url_by_id($userId)
{
}

// This function says if the user has provided e-mail and can be accessed by e-mail
// Parameters: 
// 	userId - id of the user who submitted the idea
function vox_user_accessible_by_email($userId)
{
	return false;
}

// This function defines, whether the user may submit new ideas. By default all users may submit
function vox_user_may_submit($userId)
{
	return true;
}

// This function defines, whether the idea, submitted by the user, is moderated. 
// Non-moderated idea becomes immediately accepted and visible to all users (gets New status)
// Moderated idea gets Pending status and is visible only to moderator
function vox_user_requires_moderation($userId)
{
	if ($userId == 0)
		return $GLOBALS["vox_moderate_anonymous_submissions"];
	else
		return $GLOBALS["vox_moderate_loggedin_submissions"];
}

// This function defines, whether the user may vote. By default all users may vote
function vox_user_may_vote($userId)
{
	return true;
}

// The following functions send e-mail or other notification to the user about the event (function name suggests)
// Parameters: 
// 	ideaId - id of the idea
// 	title - idea's title / caption
// 	userId - id of the user who submitted the idea
//  category_title - title of the category, to which the idea belongs
//  comment - comment which could have been left by the admin

function vox_notify_idea_rejected($ideaId, $title, $userId, $category_title, $comment)
{
}

function vox_notify_idea_accepted($ideaId, $title, $userId, $category_title, $comment)
{
}

function vox_notify_idea_planned($ideaId, $title, $userId, $category_title, $comment)
{
}

function vox_notify_idea_to_work($ideaId, $title, $userId, $category_title, $comment)
{
}

function vox_notify_idea_complete($ideaId, $title, $userId, $category_title, $comment)
{
}

// This function sends e-mail or other notification to the admin about new idea
// Parameters: 
// 	ideaId - id of the idea
// 	title - idea's title / caption
// 	desc - idea's description
// 	userId - id of the user who submitted the idea
//  userName - the name of the user who submitted the idea
//  userEMail - the e-mail address of the user who submitted the idea
//  category_title - title of the category, to which the idea belongs
//  adminId - user Id of the administrator that receives the notifications
//  adminEMail - EMail of the administrator that receives the notifications
//  widget_location - URL of the widget. Can be passed back via notification channel
function vox_notify_admin_idea_posted($ideaId, $title, $desc, $userId, $userName, $userEMail, $category_title, $adminId, $adminEMail, $widget_location = "")
{

}

// This function can be used to put the idea to To Do List management software or issue tracker
// Parameters: 
// 	ideaId - id of the idea
// 	title - idea's title / caption
// 	desc - idea's description
// 	userId - id of the user who submitted the idea
//  category_id - id of the category, to which the idea belongs
//  category_title - title of the category, to which the idea belongs
function vox_idea_to_work($ideaId, $title, $desc, $userId, $category_id, $category_title)
{

}

// This function adds a new topic to discussion forum (or alternate place for discussions)
// Parameters:
// 	forumId - id of the forum (taken from category)
//  category_title - title of the category, to which the idea belongs
// 	ideaId - id of the idea
// 	title - idea's title / caption
//  desc - idea's description
// 	userId - id of the user who submitted the idea
//  name - name of the user who submitted the idea. This field is not set if userId is defined, and is set if the idea was submitted by unregistered user.
//  email - e-mail of the user who submitted the idea. This field is not set if userId is defined, and is set if the idea was submitted by unregistered user.
// widget_location - the address of the web page, on which the widget (in which the idea has been submitted) is placed
// Result:
//  topic/thread ID for the added topic (must not be 0 or empty string)
//  or empty value (0 or empty string) if operation failed or was not performed for other reason
function vox_forum_create_topic($forumId, $category_title, $ideaId, $title, $desc, $userId, $name, $email, $widget_location = "")
{
}

// This function returns the number of comments (original message is not counted!) in the discussion of the idea
// Parameters:
// 	forumId - id of the forum (taken from category). Must not be 0
// 	topicId - id of the topic in the forum. Must not be 0
function vox_forum_get_comment_count($forumId, $topicId)
{
}

// This function returns the URL of the forum (used in category list)
// Parameters:
// 	forumId - id of the forum (taken from category). Must not be 0
function vox_forum_get_url($forumId)
{
}

// This function returns the URL of the topic in the forum (comments section)
// Parameters:
// 	forumId - id of the forum (taken from category). Must not be 0
// 	topicId - id of the topic in the forum. Must not be 0
function vox_forum_get_topic_url($forumId, $topicId)
{
}

// This function returns the URL of the new comment form in the forum
// Parameters:
// 	forumId - id of the forum (taken from category). Must not be 0
// 	topicId - id of the topic in the forum. Must not be 0
function vox_forum_get_new_comment_url($forumId, $topicId)
{
}


// These functions add a new topic to discussion forum (or alternate place for discussions)
// Parameters:
// 	forumId - id of the forum (taken from category)
//  topicId - id of the topic, created when the idea was accepted
// 	title - idea's title / caption
//  comment - comment which could have been left by the admin
// Result:
//  Anything

function vox_forumnotify_idea_planned($forumId, $topicId, $title, $comment)
{
}

function vox_forumnotify_idea_to_work($forumId, $topicId, $title, $comment)
{
}

function vox_forumnotify_idea_complete($forumId, $topicId, $title, $comment)
{
}

?>