<?

/*

VoxPopuli

Copyright (c) 2009-2011, EldoS Corporation

For licensing and distribution terms visit http://www.eldos.com/

*/

require_once('vox-constants.php');
require_once('vox-cl-base.php');
require_once('vox-cl-vote.php');

class voxIdea extends voxBase
{
	var $id, $userId, $name, $email, $title, $desc, $dateAdded, $dateStatus, $category, $forumId, $status, $votesFor, $votesAgainst;

	function voxIdea()
	{
		$this->votesFor = 0;
		$this->votesAgainst = 0;
		$this->name = "";
		$this->email = "";
	}

	function add()
	{
		voxBase::mysqlconnect();
		$query=sprintf("INSERT INTO `Ideas` ( `Id` , `UserId`, `Name`, `EMail`, `Category`, `ForumId`, `Status`, `DateAdded`, `DateStatus`, `Title`, `Description`, `VotesFor`, `VotesAgainst`) 
				VALUES ( NULL , %d, '%s', '%s', %d, '%s', %d, '%s', '%s', '%s', '%s', 0, 0 )", 
				$this->userId, escape_smart($this->name), escape_smart($this->email), 
				$this->category, escape_smart($this->forumId), $this->status, $this->dateAdded, $this->dateStatus, escape_smart($this->title), escape_smart($this->desc));
		
		$result=voxBase::mysqlquery($query);
		if ($result)
		{
			$this->id = voxBase::lastInsertId();			
		}
		return $result;
	}

	function get()
	{
		voxBase::mysqlconnect();
		$query="SELECT * FROM `Ideas` WHERE Id={$this->id}";
		$result=voxBase::mysqlquery($query);
		if ($object = mysql_fetch_object($result))
		{		
			$this->id=$object->Id;
			$this->userId=$object->UserId;
			$this->name=$object->Name;
			$this->email=$object->EMail;
			$this->title=$object->Title;
			$this->desc=$object->Description;
			$this->dateAdded=$object->DateAdded;
			$this->dateStatus=$object->DateStatus;
			$this->category=$object->Category;
			$this->forumId=$object->ForumId;
			$this->status=$object->Status;
			$this->votesFor=$object->VotesFor;
			$this->votesAgainst=$object->VotesAgainst;
		}
		return $object != FALSE;
	}
	
	function getAll()
	{
		voxBase::mysqlconnect();
		$query="SELECT * FROM `Ideas`";
		$result=voxBase::mysqlquery($query);
		$ideas=array();
		while($object = mysql_fetch_object($result))
		{
			$anIdea = new voxIdea();

			$anIdea->id=$object->Id;
			$anIdea->userId=$object->UserId;
			$anIdea->name=$object->Name;
			$anIdea->email=$object->EMail;
			$anIdea->title=$object->Title;
			$anIdea->desc=$object->Description;
			$anIdea->dateAdded=$object->DateAdded;
			$anIdea->dateStatus=$object->DateStatus;
			$anIdea->category=$object->Category;
			$anIdea->forumId=$object->ForumId;
			$anIdea->status=$object->Status;
			$anIdea->votesFor=$object->VotesFor;
			$anIdea->votesAgainst=$object->VotesAgainst;
			array_push($ideas,$anIdea);
		}
		return $ideas;
	}

	function getView($cat, $number, $show_recent)
	{
		voxBase::mysqlconnect();
		$query="SELECT * FROM `Ideas` WHERE Category={$cat} AND Status >= 4";
		if ($show_recent)
		{
			$query = $query . " ORDER BY DateAdded DESC";
		}
		else
		{
			$query = $query . " ORDER BY (VotesFor - VotesAgainst) DESC";
		}
		
		if ($number > 0)
			$query = $query . " LIMIT 0, {$number}";
		
		$result=voxBase::mysqlquery($query);
		$ideas=array();
		while($object = mysql_fetch_object($result))
		{
			$anIdea = new voxIdea();

			$anIdea->id=$object->Id;
			$anIdea->userId=$object->UserId;
			$anIdea->name=$object->Name;
			$anIdea->email=$object->EMail;
			$anIdea->title=$object->Title;
			$anIdea->desc=$object->Description;
			$anIdea->dateAdded=$object->DateAdded;
			$anIdea->dateStatus=$object->DateStatus;
			$anIdea->category=$object->Category;
			$anIdea->forumId=$object->ForumId;
			$anIdea->status=$object->Status;
			$anIdea->votesFor=$object->VotesFor;
			$anIdea->votesAgainst=$object->VotesAgainst;
			array_push($ideas,$anIdea);
		}
		return $ideas;
		
	}
	
	function getRange($offset, $number, $cat, $useronly, $openonly, $specificstatus, $sortorder, $searchterm, &$totalrows)
	{
		voxBase::mysqlconnect();
		$query = "SELECT SQL_CALC_FOUND_ROWS * FROM `Ideas`";
			
		$whereset = false;
		
		// append parameters
		if ($specificstatus > 0)
		{
			$query = $query . " WHERE Status = " . $specificstatus;
			$whereset  = true;
		}
		else
		if ($openonly)
		{
			$query = $query . " WHERE Status >= " . VOX_STATUS_NEW;
			$whereset = true;
		}
		
		if ($useronly > 0)
		{
			if ($whereset)
				$query = $query . " AND ";
			else
				$query = $query . " WHERE ";
			$query = $query . " UserId={$useronly}";
			$whereset = true;
		}

		if ($cat > 0)
		{
			if ($whereset)
				$query = $query . " AND ";
			else
				$query = $query . " WHERE ";
			$query = $query . " Category={$cat}";
			$whereset = true;
		}

		if ($searchterm != "")
		{
			if ($whereset)
				$query = $query . " AND ";
			else
				$query = $query . " WHERE ";
			$searchterm = escape_smart($searchterm);
			$query = $query . " (LOCATE('{$searchterm}', Title) > 0 OR LOCATE('{$searchterm}', Description) > 0)" ;
			$whereset = true;
		}

		if ($sortorder != "")
		{
			$query = $query . " ORDER BY ";
			if ($sortorder == "da")
				$query = $query . "DateAdded ASC";
			else
			if ($sortorder == "dd")
				$query = $query . "DateAdded DESC";
			else
			if ($sortorder == "aa")
				$query = $query . "Title ASC";
			else
			if ($sortorder == "ad")
				$query = $query . "Title DESC";			
			else
			if ($sortorder == "va")
				$query = $query . "(VotesFor + VotesAgainst) ASC";
			else
			if ($sortorder == "vd")
				$query = $query . "(VotesFor + VotesAgainst) DESC";			
			else
			if ($sortorder == "ra")
				$query = $query . "CAST((VotesFor - VotesAgainst) AS SIGNED) ASC";
			else
			if ($sortorder == "rd")
				$query = $query . "CAST((VotesFor - VotesAgainst) AS SIGNED) DESC";			
		}
		
		// append range limit
		if ($number != 0)
		{
			if ($number > 50 || $number < 1) 
				$number = 20;
			if ($offset < 0)
				$offset = 0;
			$query = $query . " LIMIT {$offset}, {$number}";
		}

		// make request

		voxBase::mysqlquery("LOCK TABLE Ideas WRITE");
		$result=voxBase::mysqlquery($query);		
		$query = "SELECT FOUND_ROWS() AS Total";
		$result_count = voxBase::mysqlquery($query);
		$totalrows = mysql_result($result_count, 0, "Total");
		voxBase::mysqlquery("UNLOCK TABLES");

		$ideas=array();
		while($object = mysql_fetch_object($result))
		{
			$anIdea = new voxIdea();

			$anIdea->id=$object->Id;
			$anIdea->userId=$object->UserId;
			$anIdea->name=$object->Name;
			$anIdea->email=$object->EMail;
			$anIdea->title=$object->Title;
			$anIdea->desc=$object->Description;
			$anIdea->dateAdded=$object->DateAdded;
			$anIdea->dateStatus=$object->DateStatus;			
			$anIdea->category=$object->Category;
			$anIdea->forumId=$object->ForumId;
			$anIdea->status=$object->Status;
			$anIdea->votesFor=$object->VotesFor;
			$anIdea->votesAgainst=$object->VotesAgainst;
			array_push($ideas,$anIdea);
		}
		return $ideas;
	}
	
	function change($reconnect = true)
	{
		if ($reconnect)
			voxBase::mysqlconnect();
			
		$query=sprintf("UPDATE `Ideas` SET `UserId` = %d, `Name`='%s', `EMail`='%s', `Category` = %d,
				`ForumId` = '%s',
				`Status` = %d,
				`DateAdded` = '%s',
				`DateStatus` = '%s',
				`Title` = '%s',
				`Description` = '%s',
				`VotesFor` = %d, 
				`VotesAgainst` = %d WHERE Id=%d",
				$this->userId, escape_smart($this->name), escape_smart($this->email), 
				$this->category, escape_smart($this->forumId), 
				$this->status, escape_smart($this->dateAdded), escape_smart($this->dateStatus), escape_smart($this->title), escape_smart($this->desc), 
				$this->votesFor, $this->votesAgainst,
				$this->id);
		$result = voxBase::mysqlquery($query);
		return $result;
	}

	function remove() // removes the vote
	{
		voxBase::mysqlconnect();
		// delete votes
		$query="DELETE FROM `Votes` WHERE IdeaId={$this->id}";
		voxBase::mysqlquery($query);
		// now delete an idea
		$query="DELETE FROM `Ideas` WHERE Id={$this->id}";
		$result = voxBase::mysqlquery($query);
		return $result;
	}

    function validate()
	{
		return (strlen($caption) < 256 && strlen($desc) < 65536 && strlen($name) < 32 && strlen($lastName) < 32);
	}

	function addVoteToCache($value)
	{
		voxBase::mysqlconnect();
		$query = "LOCK TABLE Ideas WRITE";
		voxBase::mysqlquery($query);
		$result=voxBase::mysqlquery($query);
		
		if ($this->get())
		{
			if ($value)
				$this->votesFor += 1;
			else
				$this->votesAgainst += 1;
				
			$this->change(false);
		}
		voxBase::mysqlquery("UNLOCK TABLES");
	}	
		
	function removeVoteFromCache($value)
	{
		voxBase::mysqlconnect();
		$query = "LOCK TABLE Ideas WRITE";
		voxBase::mysqlquery($query);
		$result=voxBase::mysqlquery($query);
		
		if ($this->get())
		{
			if ($value)
				$this->votesFor -= 1;
			else
				$this->votesAgainst -= 1;
				
			$this->change(false);
		}
		voxBase::mysqlquery("UNLOCK TABLES");
	}
	
}

?>