<?

require_once("vox-constants.php");

require_once("site_specific/vox-config.php");

include_once("site_specific/vox-messages.php");
require_once("site_specific/vox-rewrites.php");

$VOX_IDEA_STATUS_STYLE[VOX_STATUS_PENDING] = "vox_idea_status_pending";
$VOX_IDEA_STATUS_STYLE[VOX_STATUS_REJECTED] = "vox_idea_status_rejected";
$VOX_IDEA_STATUS_STYLE[VOX_STATUS_COMPLETE] = "vox_idea_status_complete";
$VOX_IDEA_STATUS_STYLE[VOX_STATUS_NEW] = "vox_idea_status_new";
$VOX_IDEA_STATUS_STYLE[VOX_STATUS_INWORK] = "vox_idea_status_in_progress";
$VOX_IDEA_STATUS_STYLE[VOX_STATUS_PLANNED] = "vox_idea_status_planned";

function vox_check_vote($userId, $ideaId, $cookie, &$prevvote, &$vote)
{
	if ($cookie == "")
		$cookie = "0_0";
	
	$cookies = explode("_", $cookie);
	
	$vote = new voxVote();
	$vote->userId = $userId;
	$vote->ideaId = $ideaId;
	
	$vote->ip = intval($cookies[0]);
	$vote->random = intval($cookies[1]);	
	return $vote->exists($prevvote);
}

function vox_check_can_vote($userId, $ideaId, $cookie, &$can_vote_for, &$can_vote_against, &$hide_votes)
{
	$prevvote = -1;
	$hide_votes = $GLOBALS["hide_votes_of_unvoted_ideas"];
	$vote = 0;
	
	if ($userId == 0)
	{	// check vote of anonymous user
	
		$can_vote_for = $GLOBALS["vox_allow_vote_without_login"] && ($cookie != "");
		if ($can_vote_for) 
		{
			$vote_exists = vox_check_vote(0, $ideaId, $cookie, $prevvote, $vote);
			if ($vote_exists)
			{
				$can_vote_for = ($prevvote == 0);
				$can_vote_against = $GLOBALS["vox_allow_votes_against"] && ($prevvote != 0);
				$hide_votes = false;							
			}
			else
			{
				$can_vote_for = true;
				$can_vote_against = $GLOBALS["vox_allow_votes_against"];
			}
		}
		else
		{
			$can_vote_against = false;
		}							
	}
	else
	{	// check vote of registered user
	
		if (vox_check_vote($userId, $ideaId, $cookie, $prevvote, $vote))
		{
			$can_vote_for = ($prevvote == 0);
			$can_vote_against = $GLOBALS["vox_allow_votes_against"] && ($prevvote != 0);
			$hide_votes = false;							
		}
		else
		{
			$can_vote_for = true;
			$can_vote_against = $GLOBALS["vox_allow_votes_against"];
		}
	}
}

function vox_show_continue_button_html()
{
	global $VOX_MESSAGES, $vox_language;
	echo "<br><br><center><input type=\"button\" class=\"vox_button\" onclick=\"voxUI.refreshIdeaList();\" value=\"" . $VOX_MESSAGES["vox_msg_continue_button"][$vox_language] . "\"></center>";
}			

function vox_show_query_html($message, $acceptFunc, $declineFunc)
{
	global $VOX_MESSAGES, $vox_language;
	
	$msg = $message[$vox_language];
	if (strlen($msg) == 0)
		$msg = $message["en"];
	
	echo "<b>" . $msg . "</b>" . 
		"<br><br><center>" . 
		"<input type=\"button\" class=\"vox_button\" onclick=\"" . $acceptFunc . "\" value=\"" . $VOX_MESSAGES["vox_msg_yes_button"][$vox_language] . "\">" . 
		"<input type=\"button\" class=\"vox_button\" onclick=\"" . $declineFunc . "\" value=\"" . $VOX_MESSAGES["vox_msg_no_button"][$vox_language] . "\">" .
		"</center>";
}			

function vox_format_texts($text)
{
	$text = str_replace("&", "&amp;", $text);
	$order   = array("\r\n", "\n", "\r");
	$replace = "<br />";
	return str_replace($order, $replace, $text);
}

function vox_report_success_xml($message)
{
	global $VOX_MESSAGES, $vox_language;

	if ($message != NULL)
	{
		$msg = $message[$vox_language];
		if (strlen($msg) == 0)
			$msg = $message["en"];
	}
	echo "<?xml version=\"1.0\" ?>";
	echo "<status>SUCCESS</status>";
	if (strlen($msg) > 0)
		echo '<comment>' . $msg . '</status>';
}

function vox_report_success_html($message)
{	
	global $VOX_MESSAGES, $vox_language;
	
	if ($message != null)
	{
		$msg = $message[$vox_language];
		if (strlen($msg) == 0)
			$msg = $message["en"];

		echo "<br><center><b>" . $msg . "</b></center>";
	}	
}

function vox_report_success($message = null)
{
	if ($GLOBALS["vox_xml_output"])
		vox_report_success_xml($message);
	else
		vox_report_success_html($message);
}

function vox_report_error_xml($message)
{
	global $VOX_MESSAGES, $vox_language;

	$errMsg = $message[$vox_language];
	if (strlen($errMsg) == 0)
		$errMsg = $message["en"];
	echo "<?xml version=\"1.0\" ?>";
	echo "<status>ERROR</status>";
	echo "<error>". $errMsg ."</error>";

}

function vox_report_error($message)
{	
	if ($GLOBALS["vox_xml_output"] == true)
		vox_report_error_xml($message);
	else
		vox_report_error_html($message);
}

function vox_report_error_html($message)
{
	global $VOX_MESSAGES, $vox_language;

	$errTitle = $VOX_MESSAGES["vox_msg_error"][$vox_language];
	if (strlen($errTitle) == 0)
		$errTitle = $VOX_MESSAGES["vox_msg_error"]["en"];

	$errMsg = $message[$vox_language];
	if (strlen($errMsg) == 0)
		$errMsg = $message["en"];

	echo '<h3>' . $errTitle . ':</h3>' . $errMsg;
}

function vox_show_empty_search_results_html()
{
	global $VOX_MESSAGES, $vox_language;
	echo "<br><br><center>" . $VOX_MESSAGES["vox_msg_no_ideas_found"][$vox_language] . "</center>";
}

function vox_show_empty_search_results_view_html()
{
	global $VOX_MESSAGES, $vox_language;
	echo "<center>" . $VOX_MESSAGES["vox_msg_no_ideas_found"][$vox_language] . "</center>";
}

function vox_show_empty_search_results_xml()
{
	// does nothing
}

function vox_show_empty_search_results()
{
	if ($GLOBALS["vox_xml_output"] == true)
		vox_show_empty_search_results_xml();
	else
		vox_show_empty_search_results_html();
}

function vox_rawlist_html($listing)
{
	global $VOX_IDEA_STATUS_STYLE, $VOX_MESSAGES, $vox_language, $vox_view_show_votes;
?>
	<div id="vox_idea_list">
<?	
	if ($listing["count"] == 0)
		 vox_show_empty_search_results_view_html();
	else
	{
		for ($i = 0; $i < $listing["count"]; $i++)
		{
		
			$ideaId = $listing[$i]["id"];
					
			$votesAgainst = 0;
			$votesFor = $listing[$i]["votesfor"];
			$votesTotal = $votesFor;
			if ($GLOBALS["vox_allow_votes_against"])
			{
				$votesAgainst = $listing[$i]["votesagainst"];
				$votesTotal = $votesFor - $votesAgainst;		
			}		
?>
			<div id="vox_idea_<?=$ideaId?>" class="<? if ($i % 2 == 1) echo "vox_idea_odd"; else echo "vox_idea_even";?>">
				
				<? if ($vox_view_show_votes) { ?>
				<div class="vox_idea_vote_counter">
					<div class="vox_idea_vote_count">
					<a name="<?=$ideaId?>_votes"><?=$votesTotal?></a>
					</div>
					<?=$VOX_MESSAGES["vox_msg_details_votes"][$vox_language]?>
				</div>
				<? } ?>
				
				<div class="vox_idea_info">
					<? 
					$show_status = ($GLOBALS["vox_view_show_status_new"] && ($listing[$i]["ideastatus"] == VOX_STATUS_NEW)) ||
									($GLOBALS["vox_view_show_status_inprogress"] && ($listing[$i]["ideastatus"] == VOX_STATUS_INWORK)) ||
									($GLOBALS["vox_view_show_status_planned"] && ($listing[$i]["ideastatus"] == VOX_STATUS_PLANNED));
					if ($show_status)
					{					
					?>
					<br>
					<div class="vox_idea_misc_info">
						<div class="<?=$VOX_IDEA_STATUS_STYLE[$listing[$i]["ideastatus"]]?>"><?=$listing[$i]["ideastatusname"]?></div>						
					</div>					
					<?
					}
					?>
					<div class="vox_idea_title"><?=$listing[$i]["title"]?></div>
					<?
					if ($listing[$i]["desc"] != "") 
					{
						echo "<div id=\"vox_idea_more_" . $ideaId . "\" class=\"vox_idea_desc\">" . $listing[$i]["desc"] . "</div>";
					}
					?>
				</div>
			</div>
<?
		}
	}
	echo "</div>";
}

function vox_view_idealist_html($listing)
{
	global $VOX_IDEA_STATUS_STYLE, $VOX_MESSAGES, $vox_language, $vox_view_show_votes;
?>
	<div id="vox_idea_list">
<?	
	if ($listing["count"] == 0)
		 vox_show_empty_search_results_view_html();
	else
	{
		for ($i = 0; $i < $listing["count"]; $i++)
		{
		
			$ideaId = $listing[$i]["id"];
					
			$votesAgainst = 0;
			$votesFor = $listing[$i]["votesfor"];
			$votesTotal = $votesFor;
			if ($GLOBALS["vox_allow_votes_against"])
			{
				$votesAgainst = $listing[$i]["votesagainst"];
				$votesTotal = $votesFor - $votesAgainst;		
			}		
?>
			<div id="vox_idea_<?=$ideaId?>" class="<? if ($i % 2 == 1) echo "vox_idea_odd"; else echo "vox_idea_even";?>">
				
				<? if ($vox_view_show_votes) { ?>
				<div class="vox_idea_vote_counter">
					<div class="vox_idea_vote_count">
					<a name="<?=$ideaId?>_votes"><?=$votesTotal?></a>
					</div>
					<?=$VOX_MESSAGES["vox_msg_details_votes"][$vox_language]?>
				</div>
				<? } ?>
				
				<div class="vox_idea_info">
					<div class="vox_idea_title"><?=$listing[$i]["title"]?></div>
					<? 
					$show_status = ($GLOBALS["vox_view_show_status_new"] && ($listing[$i]["ideastatus"] == VOX_STATUS_NEW)) ||
									($GLOBALS["vox_view_show_status_inprogress"] && ($listing[$i]["ideastatus"] == VOX_STATUS_INWORK)) ||
									($GLOBALS["vox_view_show_status_planned"] && ($listing[$i]["ideastatus"] == VOX_STATUS_PLANNED));
					if ($show_status)
					{					
					?>
					<br>
					<div class="vox_idea_misc_info">
						<div class="<?=$VOX_IDEA_STATUS_STYLE[$listing[$i]["ideastatus"]]?>"><?=$listing[$i]["ideastatusname"]?></div>						
					</div>					
					<?
					}
					?>
				</div>
			</div>
<?
		}
	}
	echo "</div>";
}


function vox_show_widget_box($categoryId)
{
	global $VOX_MESSAGES, $vox_language;
	$curUserId = vox_user_get_id();
	$isAdmin  = vox_user_is_admin();
	
	// we possibly need to set a new cookie
	if ($curUserId == 0 && $_COOKIE["VOX_ID"] == "")
	{
		$newCookie = ip2long($_SERVER["REMOTE_ADDR"]) . "_" . rand(0, 0x7fffffff);
		setcookie("VOX_ID", $newCookie, time()+60*60*24*366, "/", $_REQUEST["HTTP_HOST"]);
	}	
?>

	<div id="vox_header">
		<?=$VOX_MESSAGES["vox_msg_ideas_welcome"][$vox_language]?>
	</div>
	
	<ul id="vox_tabs">
		<li id="vox_tab_open" class="vox_tab"><a href="javascript:void(0)" onclick="voxUI.showTab('open');"><span><?=$VOX_MESSAGES["vox_msg_tab_open"][$vox_language]?></span></a></li>
		<? 
		
		if ($isAdmin == false || $GLOBALS["admin_show_my_complete_tabs"] == true)
		{
			if ($curUserId > 0) { 
		?>
				<li id="vox_tab_my" class="vox_tab"><a href="javascript:void(0)" onclick="voxUI.showTab('my');"><span><?=$VOX_MESSAGES["vox_msg_tab_my"][$vox_language]?></span></a></li>
		<?
			}
		?>
			<li id="vox_tab_complete" class="vox_tab"><a href="javascript:void(0)" onclick="voxUI.showTab('complete');"><span><?=$VOX_MESSAGES["vox_msg_tab_complete"][$vox_language]?></span></a></li>
		<?			
		}
		
		if ($isAdmin || vox_user_has_rights($categoryId, VOX_OPERATION_APPROVE_IDEA))
		{
		?>
			<li id="vox_tab_pending" class="vox_tab"><a href="javascript:void(0)" onclick="voxUI.showTab('pending', VOX_STATUS_PENDING);"><span><?=$VOX_MESSAGES["vox_msg_tab_pending"][$vox_language]?></span></a></li>
		<?
		}
		if ($isAdmin)
		{
		?>
			<li id="vox_tab_all" class="vox_tab"><a href="javascript:void(0)" onclick="voxUI.showTab('all');"><span><?=$VOX_MESSAGES["vox_msg_tab_all"][$vox_language]?></span></a></li>
		<?
		}
		if ($isAdmin || vox_user_has_rights($categoryId, VOX_OPERATION_VIEW_CATEGORIES))
		{
		?>
			<li id="vox_tab_cat" class="vox_tab"><a href="javascript:void(0)" onclick="voxUI.showTab('cat');"><span><?=$VOX_MESSAGES["vox_msg_tab_cat"][$vox_language]?></span></a></li>
		<?
		}
		?>		
	</ul>
	<div id="vox_content">
		<div id="vox_progress_holder" style="display: none; ">
			<img src="<?=$GLOBALS["vox_script_location"]?>/site_specific/ajax-loader.gif">
		</div>
		<div id="vox_tab_content">
		</div>		
	</div>
	<div class="vox_ie_breaker"><br></div>
	<? 
	
	$can_submit = (($GLOBALS["vox_allow_submit_without_login"] == true) || ($curUserId > 0))  && vox_user_may_submit($curUserId);
	
	if ($can_submit) {
	?>
	<a id="vox_suggestion_link" href="javascript:void(0)" onclick="voxUI.addIdea();">
	<? } ?>
	<div id="vox_suggestion_button"<? if ($can_submit == false) echo "style=\"color: grey;\""; ?>><?=$VOX_MESSAGES["vox_msg_suggest_an_idea"][$vox_language]?></div>
	<? if ($can_submit) echo "</a>"; ?>	
	
	<div id="vox_footer">
		<!-- IMPORTANT: Removal, modification, hiding or alteration of contents of this div block or any of it's contents including this notice is strictly prohibited by the license -->		
		<?
			if ($GLOBALS["vox_home_link"] != "")
				$link = $GLOBALS["vox_home_link"];
			else
				$link = "Powered&nbsp;by&nbsp;<a href=\"http://www.eldos.com/\">VoxPopuli</a>";	

			echo $link;
		?>
		
	</div>
</div>

<?
}

function vox_output_idealist_html($listing, $category, $fetchdesc = false)
{
	global $VOX_IDEA_STATUS_STYLE, $VOX_MESSAGES, $vox_language, $global_color_search_active, $global_color_search_inactive; 
	
	$showCategory = $category == -1;
	
	$curUserId = vox_user_get_id();
	$items_per_page = $listing["number"];
	$sort_order = $listing["sortorder"];
	$searchterm = $listing["search"];
	if ($searchterm == "")
		$searchterm = "Search";
?>
	
	<div id="vox_top_line">
	
		<div id="vox_search">
			<input type="text" id="vox_search_input" value="<?=$searchterm?>" onClick="if (this.value=='Search') { this.value=''; this.style.color='<?=$global_color_search_active?>'; }" onKeyDown="voxUI.searchInputKeyDown(event, '<?=$global_color_search_active?>', '<?=$global_color_search_inactive?>')" onblur="if (this.value=='') { this.value='Search'; this.style.color='<?=$global_color_search_inactive?>'; };" /> 
			<input type="image" align="top" src="<?=$GLOBALS["vox_script_location"]?>/search.gif" alt="Search" onclick="voxUI.performSearch();"/>
		</div>
		
		<?
		?>		
		<div id="vox_sort_box">
			<?=$VOX_MESSAGES["vox_msg_sort_by"][$vox_language]?>
			<select id="vox_sort_by" onchange="voxUI.setSortOrder(this.value)">
				<option value="da" <?if ($sort_order == "da") echo "selected"; ?>><?=$VOX_MESSAGES["vox_msg_sort_date_asc"][$vox_language]?></option>
				<option value="dd" <?if ($sort_order == "dd") echo "selected"; ?>><?=$VOX_MESSAGES["vox_msg_sort_date_desc"][$vox_language]?></option>
				<option value="aa" <?if ($sort_order == "aa") echo "selected"; ?>><?=$VOX_MESSAGES["vox_msg_sort_title_asc"][$vox_language]?></option>
				<option value="ad" <?if ($sort_order == "ad") echo "selected"; ?>><?=$VOX_MESSAGES["vox_msg_sort_title_desc"][$vox_language]?></option>
			<? if ($GLOBALS["vox_allow_votes_against"]) { ?>
				<option value="va" <?if ($sort_order == "va") echo "selected"; ?>><?=$VOX_MESSAGES["vox_msg_sort_votes_asc"][$vox_language]?></option>
				<option value="vd" <?if ($sort_order == "vd") echo "selected"; ?>><?=$VOX_MESSAGES["vox_msg_sort_votes_desc"][$vox_language]?></option>
			<?
			}
			?>			
				<option value="ra" <?if ($sort_order == "ra") echo "selected"; ?>><?=$VOX_MESSAGES["vox_msg_sort_rating_asc"][$vox_language]?></option>
				<option value="rd" <?if ($sort_order == "rd") echo "selected"; ?>><?=$VOX_MESSAGES["vox_msg_sort_rating_desc"][$vox_language]?></option>
			</select>
		</div>
		<div class="vox_cleaner"></div>
	</div>
	
	<div id="vox_idea_list">
<?	
	if ($listing["count"] == 0)
		vox_show_empty_search_results_html();
	else
	{
		for ($i = 0; $i < $listing["count"]; $i++)
		{
		
			$ideaId = $listing[$i]["id"];
					
			$votesAgainst = 0;
			$votesFor = $listing[$i]["votesfor"];
			$votesTotal = $votesFor;
			if ($GLOBALS["vox_allow_votes_against"])
			{
				$votesAgainst = $listing[$i]["votesagainst"];
				$votesTotal = $votesFor - $votesAgainst;		
			}		
?>
			<div id="vox_idea_<?=$ideaId?>" class="<? if ($i % 2 == 1) echo "vox_idea_odd"; else echo "vox_idea_even";?>">
				<div class="vox_idea_vote_counter">
					<? 					
					$can_vote = ($listing[$i]["ideastatus"] >= VOX_STATUS_CAN_VOTE_FIRST) && ($listing[$i]["ideastatus"] <= VOX_STATUS_CAN_VOTE_LAST) && vox_user_may_vote($curUserId);
					if ($can_vote) 
					{ 
						vox_check_can_vote($curUserId, $ideaId, $_COOKIE["VOX_ID"], $can_vote_for, $can_vote_against, $hide_votes);
					
						if ($GLOBALS["vox_allow_votes_against"])
							$details_hint = sprintf($VOX_MESSAGES["vox_msg_details_hint_2"][$vox_language], $votesFor, $votesAgainst); 
						else
							$details_hint = sprintf($VOX_MESSAGES["vox_msg_details_hint_1"][$vox_language], $votesFor); 
						?>
						<div class="vox_idea_vote_count">
						<?
						if ((vox_user_is_admin() == false) && (vox_user_has_rights($category, VOX_OPERATION_VIEW_VOTES) == false) && $hide_votes)
							echo "<a name=\"" . $ideaId ."_votes\" title=\"" . $VOX_MESSAGES["vox_msg_vote_to_see_votes"][$vox_language] . "\"></a>";
						else
							echo "<a name=\"" . $ideaId ."_votes\" title=\"" . $details_hint . "\">" . $votesTotal . "</a>";					
						?>
						</div>
						
						<div class="vox_idea_vote_signs">
							<?
							if ($can_vote_for)
							{
							?>
							<a href="javascript:void(0)" class="vox_idea_vote_glyph" title="<?=$VOX_MESSAGES["vox_msg_vote_for_this_idea"][$vox_language]?>"><img src="<?=$GLOBALS["vox_script_location"]?>/site_specific/votefor.gif" border="0" onclick="voxUI.voteForIdea(<?=$ideaId?>, 1)"></a>
							<?
							}
							if ($can_vote_against)
							{ 
							?>
							<a href="javascript:void(0)" class="vox_idea_vote_glyph" title="<?=$VOX_MESSAGES["vox_msg_vote_against_this_idea"][$vox_language]?>"><img src="<?=$GLOBALS["vox_script_location"]?>/site_specific/voteagainst.gif" border="0" onclick="voxUI.voteForIdea(<?=$ideaId?>, 0)"></a>
							<? 
							} 
							?>
						</div>
					<? 
					} 
					?>			
				</div>
				<div class="vox_idea_info">
					<? 
					if ($showCategory == true) 
					{
						echo "<div class=\"vox_idea_category_info\">" . $listing[$i]["category"] . "</div>";
					}
					?>
					<div class="vox_idea_misc_info">
						<div class="<?=$VOX_IDEA_STATUS_STYLE[$listing[$i]["ideastatus"]]?>"><?=$listing[$i]["ideastatusname"]?></div>
						<div class="vox_idea_date"><?=$listing[$i]["dateadded"]?>
						<? 
						if (strlen($listing[$i]["username"]) > 0)
						{
							echo " " . $VOX_MESSAGES["vox_msg_created_by"][$vox_language] . " ";
							if (strlen($listing[$i]["usercontact"]) > 0)
								echo "<a href=\"" . $listing[$i]["usercontact"] . "\" class=\"vox_idea_by_link\">" . $listing[$i]["username"] . "</a>";
							else
								echo $listing[$i]["username"];
						}
						?>
						</div>
					</div>
					<div class="vox_idea_title"><?=$listing[$i]["title"]?> <? if ($listing[$i]["desc"] != "") { ?><div class="vox_idea_more"><a href="javascript:void(0)" id="vox_idea_more_<?=$ideaId?>_morelink" class="vox_idea_more_link" onclick="voxUI.showIdeaDescription('<?=$ideaId?>', true)">&gt;&gt;&gt;</a><a href="javascript:void(0)" id="vox_idea_more_<?=$ideaId?>_lesslink" class="vox_idea_more_link" onclick="voxUI.hideIdeaDescription('<?=$ideaId?>')" style="display: none; ">&lt;&lt;&lt;</a></div> <?}?>
					</div>
				
					<?
					if ($listing[$i]["desc"] != "") 
					{
						echo "<div id=\"vox_idea_more_" . $ideaId . "\" class=\"vox_idea_desc\">";
						if ($fetchdesc) 
							echo $listing[$i]["desc"]; 
						echo "</div>";
					}
					?>
					
					<?
					if ($listing[$i]["newcommenturl"] != "")
					{
					?>
						<div class="vox_idea_forum_ref">
							<? if ($listing[$i]["comments"] > 0) {
								$msg = sprintf($VOX_MESSAGES["vox_msg_comment_number"][$vox_language], $listing[$i]["comments"]);					
							?>
								<a href="<?=$listing[$i]["commenturl"]?>" target="_blank" class="vox_idea_forum_ref_link"><?=$msg?></a>&nbsp;|&nbsp;
							<?  }  ?>
							<a href="<?=$listing[$i]["newcommenturl"]?>" target="_blank" class="vox_idea_forum_ref_link"><?=$VOX_MESSAGES["vox_msg_add_comment"][$vox_language]?></a>
						</div>			
					<? 
					}
?>
				</div>
<?
				$isAdmin = vox_user_is_admin();
				if ($isAdmin || vox_user_has_rights($category, VOX_OPERATION_MODERATE_IDEA)) 
				{ 
					$commandShown = false;			
					echo "<div class=\"vox_item_operations\">";
					$ideaStatus = $listing[$i]["ideastatus"];
					if (($ideaStatus == VOX_STATUS_PENDING) && ($isAdmin || vox_user_has_rights($category, VOX_OPERATION_APPROVE_IDEA))) 
					{ 
						echo "<a href=\"javascript:void(0)\" class=\"vox_item_operation_link\" onclick=\"voxUI.setIdeaStatus({$ideaId}, " . VOX_STATUS_NEW . ")\">{$VOX_MESSAGES["vox_msg_accept_link"][$vox_language]}</a>";
						$commandShown = true;
					} 
					if (($ideaStatus == VOX_STATUS_NEW) && ($isAdmin || vox_user_has_rights($category, VOX_OPERATION_CHANGE_IDEA_STATUS)))
					{ 
						if ($commandShown) echo "&nbsp;|&nbsp;";
						echo "<a href=\"javascript:void(0)\" class=\"vox_item_operation_link\" onclick=\"voxUI.setIdeaStatus({$ideaId}, " . VOX_STATUS_PLANNED . ")\">{$VOX_MESSAGES["vox_msg_plan_link"][$vox_language]}</a>";
						$commandShown = true;
					} 
					if (($ideaStatus == VOX_STATUS_NEW || $ideaStatus == VOX_STATUS_PLANNED) && ($isAdmin || vox_user_has_rights($category, VOX_OPERATION_CHANGE_IDEA_STATUS)))
					{ 
						if ($commandShown) echo "&nbsp;|&nbsp;";
						echo "<a href=\"javascript:void(0)\" class=\"vox_item_operation_link\" onclick=\"voxUI.setIdeaStatus({$ideaId}, " . VOX_STATUS_INWORK . ")\">{$VOX_MESSAGES["vox_msg_towork_link"][$vox_language]}</a>";
						$commandShown = true;
					} 
					if (($ideaStatus == VOX_STATUS_NEW || $ideaStatus == VOX_STATUS_INWORK || $ideaStatus == VOX_STATUS_PLANNED) && ($isAdmin || vox_user_has_rights($category, VOX_OPERATION_CHANGE_IDEA_STATUS)))
					{ 
						if ($commandShown) echo "&nbsp;|&nbsp;";
						echo "<a href=\"javascript:void(0)\" class=\"vox_item_operation_link\" onclick=\"voxUI.setIdeaStatus({$ideaId}, " . VOX_STATUS_COMPLETE . ")\">{$VOX_MESSAGES["vox_msg_complete_link"][$vox_language]}</a>";
						$commandShown = true;
					} 
					if (($ideaStatus >= VOX_STATUS_NEW || $ideaStatus == VOX_STATUS_PENDING) && ($isAdmin || vox_user_has_rights($category, VOX_OPERATION_REJECT_IDEA)))
					{
						if ($commandShown) echo "&nbsp;|&nbsp;";
						echo "<a href=\"javascript:void(0)\" class=\"vox_item_operation_link\" onclick=\"voxUI.setIdeaStatus({$ideaId}, " . VOX_STATUS_REJECTED . ")\">{$VOX_MESSAGES["vox_msg_reject_link"][$vox_language]}</a>";
						$commandShown = true;
					}
					if (($ideaStatus == VOX_STATUS_PENDING || $ideaStatus == VOX_STATUS_NEW || $ideaStatus == VOX_STATUS_INWORK || $ideaStatus == VOX_STATUS_PLANNED) 
						&& ($isAdmin || vox_user_has_rights($category, VOX_OPERATION_EDIT_IDEA)))
					{
						if ($commandShown) echo "&nbsp;|&nbsp;";
						echo "<a href=\"javascript:void(0)\" class=\"vox_item_operation_link\" onclick=\"voxUI.editIdea({$ideaId})\">{$VOX_MESSAGES["vox_msg_edit_link"][$vox_language]}</a>";
						$commandShown = true;
					}					
					if (($ideaStatus == VOX_STATUS_PENDING || $ideaStatus == VOX_STATUS_COMPLETE || $ideaStatus == VOX_STATUS_REJECTED)
						&& ($isAdmin || vox_user_has_rights($category, VOX_OPERATION_DELETE_IDEA)))
					{
						if ($commandShown) echo "&nbsp;|&nbsp;";
						echo "<a href=\"javascript:void(0)\" class=\"vox_item_operation_link\" onclick=\"voxUI.deleteIdea({$ideaId}, 0)\">{$VOX_MESSAGES["vox_msg_delete_link"][$vox_language]}</a>";
						$commandShown = true;
					} 
					if ($isAdmin || vox_user_has_rights($category, VOX_OPERATION_MOVE_IDEA_FROM))
					{ 
						if ($commandShown) echo "&nbsp;|&nbsp;";
						echo "<a href=\"javascript:void(0)\" class=\"vox_item_operation_link\" onclick=\"voxUI.moveIdea({$ideaId})\">{$VOX_MESSAGES["vox_msg_move_link"][$vox_language]}</a>";
						$commandShown = true;
					} 
					
					echo "</div>";
				} 
				?>
				
				<div class="vox_cleaner"></div>
			</div>
<?
		}
	}
?>		
	</div>
	
	<!-- Navigation -->
	<div id="vox_content_footer">		
	
<?
	$total_count = $listing["totalcount"];
	$totalpages = floor($total_count / $items_per_page);
	
	if (($total_count % $items_per_page) > 0)
		$totalpages++;
		
	$curpage = $listing["startfrom"] / $items_per_page + 1;
	
	//if ($GLOBALS["vox_debug"] == true) $totalpages++;
	
	if ($totalpages > 1)
	{
		echo "<div id=\"vox_nav_bar\">";
	
		// display previous page link
		if ($curpage > 1)
		{
			echo "<a id=\"vox_prev_page\" class=\"page_nav_link\" href=\"javascript:void(0)\" title=\"" . $VOX_MESSAGES["vox_msg_previous_page"][$vox_language] . "\" onclick=\"voxUI.gotoPage(" . ($curpage - 2) . ");\">&nbsp;&lt;&lt;&nbsp;</a>";
		}
		
		// display page combobox
		if ($totalpages > 1)
		{
			echo "<select id=\"vox_page_num\" onchange=\"voxUI.gotoPage(this.value);\">";
		
			for ($i = 0; $i < $totalpages; $i++)
			{
				echo "<option value=\"" . $i . "\""; 
				if ($i == $curpage - 1) echo "selected";
				echo ">" . ($i + 1) . "</option>";
			}
				
			echo "</select>";
		}
		
		// display next page link
		if ($curpage < $totalpages)
		{
			echo "<a id=\"vox_next_page\" class=\"page_nav_link\" href=\"javascript:void(0)\" title=\"" . $VOX_MESSAGES["vox_msg_next_page"][$vox_language] . "\" onclick=\"voxUI.gotoPage(" . $curpage . ");\">&nbsp;&gt;&gt;&nbsp;</a>";
		}
		echo "</div>";
		
	}
?>	
		
		<div id="vox_ipp_select">
		<?=$VOX_MESSAGES["vox_msg_view"][$vox_language]?>
		<select id="vox_ideas_per_page" onchange="voxUI.setIdeasPerPage(this.value)">
			<option value="5" <?if ($items_per_page == 5) echo "selected"; ?>>5</option>
			<option value="10" <?if ($items_per_page == 10) echo "selected"; ?>>10</option>
			<option value="20" <?if ($items_per_page == 20) echo "selected"; ?>>20</option>		
		</select>
		<?=$VOX_MESSAGES["vox_msg_ideas_per_page"][$vox_language]?>

	</div>
<?
}

function vox_output_category_list_html($listing)
{
	global $VOX_MESSAGES, $vox_language;
	
	$count = count($listing);
	
?>	
	<div id="vox_category_add_line">
<?
	if (vox_user_is_admin() || vox_user_has_rights(0, VOX_OPERATION_ADD_CATEGORY))
	{	
?>
	<a href="javascript:void(0)" id="vox_category_add_link" onclick="voxUI.addCategory()"><?=$VOX_MESSAGES["vox_msg_addcategory_link"][$vox_language]?></a>
<?}?>
	
	</div>
	
	<div id="vox_category_list">	
<?	
	
	for ($i = 0; $i < $count; $i++)
	{
		$catId = $listing[$i]["id"];

		echo "<div id=\"{$catId}\" class=\""; if ($i % 2 == 1) echo "vox_category_odd"; else echo "vox_category_even"; echo "\">";
		echo "<div class=\"vox_category_title\">" . $listing[$i]["id"] . '. ' . $listing[$i]["name"] . "</div>";
		if ($listing[$i]["forumid"] != "")
		{
			echo "<div class=\"vox_category_forum\">Forum ID: " . $listing[$i]["forumid"];
			if ($listing[$i]["forumurl"] != "")
				echo " (<a class=\"vox_category_forum_link\" href=\"" . $listing[$i]["forumurl"] . "\">" . $VOX_MESSAGES["vox_msg_visit_forum"][$vox_language] . "</a>)";
			echo "</div>";
		}
		else 
			echo "<div class=\"vox_category_forum\">Forum ID: " . $VOX_MESSAGES["vox_msg_not_set"][$vox_language] . "</div>";

?>
		<div class="vox_item_operations">
			<a href="javascript:void(0)" class="vox_item_operation_link" onclick="voxUI.editCategory(<?=$catId?>)"><?=$VOX_MESSAGES["vox_msg_edit_link"][$vox_language]?></a>&nbsp;|&nbsp;<a href="javascript:void(0)" class="vox_item_operation_link" onclick="voxUI.deleteCategory(<?=$catId?>, 0)"><?=$VOX_MESSAGES["vox_msg_delete_link"][$vox_language]?></a>
		</div>
<?
		echo "</div>";
	}
	echo "</div>";
}

function vox_show_idea_form_html($ideaId)
{
	global $VOX_MESSAGES, $vox_language;

	$title = "";
	$desc = "";
	$name = "";
	$email = "";
	$idea = new voxIdea();
	if ($ideaId > 0)
	{
		$idea->id = $ideaId;
		if ($idea->get())
		{
			$title = htmlspecialchars($idea->title);
			$desc = htmlspecialchars($idea->desc);
			$name = htmlspecialchars($idea->name);
			$email = htmlspecialchars($idea->email);
		}
		else
		{
			vox_report_error($VOX_MESSAGES["vox_msg_failed_to_retrieve_idea"]);
			vox_show_continue_button_html();
			return;
		}
		$formTitle = $VOX_MESSAGES["vox_msg_change_idea"][$vox_language];
		$submitBtnTitle = $VOX_MESSAGES["vox_msg_update"][$vox_language];
	}
	else
	{
		$formTitle = $VOX_MESSAGES["vox_msg_share_your_idea"][$vox_language];
		$submitBtnTitle = $VOX_MESSAGES["vox_msg_share"][$vox_language];
	}
?>

	<div id="vox_details_caption">
		<div id="vox_details_caption_close_button"><a href="javascript:void(0)" onclick="voxUI.closeIdeaSubmitForm(false);">x</a></div>
		<div id="vox_details_caption_text"><?=$formTitle?></div>
	</div>
	<div id="vox_details_content">
		<span class="vox_form_field_title"><?=$VOX_MESSAGES["vox_msg_brief_description"][$vox_language]?></span><br><input id="vox_ideasubmit_title" class="vox_text" type="text" maxLength="255" value="<?=$title?>">
		<br><br>
		<span class="vox_form_field_title"><?=$VOX_MESSAGES["vox_msg_detailed_description"][$vox_language]?></span><br><textarea id="vox_ideasubmit_desc" class="vox_textarea" rows="7"><?=$desc?></textarea>
		<? if ($ideaId > 0 || vox_user_get_id() == 0) { ?>
		<br><br>
		<span class="vox_form_field_title"><?=$VOX_MESSAGES["vox_msg_your_name"][$vox_language]?></span><br><input id="vox_ideasubmit_name" class="vox_text" type="text" maxLength="64" value="<?=$name?>">
		<br><br>
		<span class="vox_form_field_title"><?=$VOX_MESSAGES["vox_msg_your_email"][$vox_language]?></span><br><input id="vox_ideasubmit_email" class="vox_text" type="text" maxLength="64" value="<?=$email?>">
		<? } ?>
		<p>
		<a class="vox_action_link" href="javascript:void(0)" onclick="voxUI.closeIdeaSubmitForm(true);"><div class="vox_action_button"><?=$submitBtnTitle?></div></a>
	</div>
<?
}

function vox_show_move_form_html($ideaId)
{
	global $VOX_MESSAGES, $vox_language;

	$idea = new voxIdea();
	$idea->id = $ideaId;
		
	if ($idea->id > 0 || $idea->get())
	{
		$formTitle = $VOX_MESSAGES["vox_msg_move_idea"][$vox_language];
		$submitBtnTitle = $VOX_MESSAGES["vox_msg_move"][$vox_language];
	}
	else
	{
		vox_report_error($VOX_MESSAGES["vox_msg_failed_to_retrieve_idea"]);
		vox_show_continue_button_html();
		return;
	}
?>
	<div id="vox_details_caption">
		<div id="vox_details_caption_close_button"><a href="javascript:void(0)" onclick="voxUI.closeIdeaMoveForm(false);">x</a></div>
		<div id="vox_details_caption_text"><?=$formTitle?></div>
	</div>
	<div id="vox_details_content">
		<span class="vox_form_field_title"><?=$VOX_MESSAGES["vox_msg_category_list"][$vox_language]?></span><br>
		<input type="hidden" id="vox_ideamove_id" value="<?=$ideaId?>">
		<select id="vox_ideamove_category_list" class="vox_text">
		<?
		$categories = voxCategory::getAll();
		foreach ($categories as $category)
		{
			echo "<option value=\"" . $category->id . "\"";
			if ($idea->category == $category->id)
				echo "selected";
			echo ">" . $category->name . "</option>";
		}
		?>
		</select>
		<p>
		<a class="vox_action_link" href="javascript:void(0)" onclick="voxUI.closeIdeaMoveForm(true);"><div class="vox_action_button"><?=$submitBtnTitle?></div></a>
	</div>
<?
}

function vox_show_cat_form_html($catId)
{
	global $VOX_MESSAGES, $vox_language;
		
	$name = "";
	$forumId = "";
	$cat = new voxCategory();
	if ($catId > 0)
	{
		$cat->id = $catId;
		if ($cat->get())
		{
			$name = htmlspecialchars($cat->name);
			$forumId = htmlspecialchars($cat->forumId);
		}
		else
		{
			vox_report_error($VOX_MESSAGES["vox_msg_failed_to_retrieve_category"]);
			vox_show_continue_button_html();
			return;
		}
		$formTitle = $VOX_MESSAGES["vox_msg_edit_category"][$vox_language];
		$submitBtnTitle = $VOX_MESSAGES["vox_msg_update"][$vox_language];
	}
	else
	{
		$formTitle = $VOX_MESSAGES["vox_msg_add_category"][$vox_language];
		$submitBtnTitle = $VOX_MESSAGES["vox_msg_add"][$vox_language];
	}
?>

	<div id="vox_details_caption">
		<div id="vox_details_caption_close_button"><a href="javascript:void(0)" onclick="voxUI.closeCatSubmitForm(false);">x</a></div>
		<div id="vox_details_caption_text"><?=$formTitle?></div>
	</div>
	<div id="vox_details_content">
		<?
		if ($catId > 0)
			echo "<h4>" . $VOX_MESSAGES["vox_msg_category_num"][$vox_language] . $catId . "</h4><br>";
		?>
		<span class="vox_form_field_title"><?=$VOX_MESSAGES["vox_msg_category_name"][$vox_language]?></span><br><input id="vox_catsubmit_name" class="vox_text" type="text" maxLength="32" value="<?=$name?>">
		<br><br>
		<span class="vox_form_field_title"><?=$VOX_MESSAGES["vox_msg_category_forumid"][$vox_language]?></span><br><input id="vox_catsubmit_forumid" class="vox_text" type="text" maxLength="32" value="<?=$forumId?>">
		<p>
		<a class="vox_action_link" href="javascript:void(0)" onclick="voxUI.closeCatSubmitForm(true);"><div class="vox_action_button"><?=$submitBtnTitle?></div></a>
	</div>
<?

}

function vox_show_status_form($ideaId, $status)
{
	global $VOX_MESSAGES, $vox_language;

	$idea = new voxIdea();			
	$idea->id = $ideaId;
	if ($idea->get())
	{		
		$category = $idea->category;
	
		if (!vox_user_is_admin() && (vox_user_has_rights($category, VOX_OPERATION_CHANGE_IDEA_STATUS) == false))
		{
			vox_report_error($VOX_MESSAGES["vox_msg_action_may_not_change_status"]);
			vox_show_continue_button_html();		
		}
		else
		if ($status < VOX_STATUS_FIRST || $status > VOX_STATUS_LAST)
		{
			vox_report_error($VOX_MESSAGES["vox_msg_invalid_parameter"]);
			vox_show_continue_button_html();		
		}
		else
		{
			$submitBtnTitle = $VOX_MESSAGES["vox_msg_status_change"][$vox_language];
?>
			<div id="vox_details_caption">
				<div id="vox_details_caption_close_button"><a href="javascript:void(0)" onclick="voxUI.closeStatusChangeForm(false);">x</a></div>
				<div id="vox_details_caption_text"><?=$VOX_MESSAGES["vox_msg_status_form_caption"][$vox_language]?></div>
			</div>
			<div id="vox_details_content">
				<input type="hidden" id="vox_ideastatus_id" value="<?=$ideaId?>">
				<input type="hidden" id="vox_ideastatus_status" value="<?=$status?>">
				<br>
				<span class="vox_form_field_title"><?=$VOX_MESSAGES["vox_msg_status_comment"][$vox_language]?></span>
				<br>
				<? 
				$allow_comment = false;
				if ($idea->userId > 0)
				{	
					$allow_comment = vox_user_accessible_by_email($idea->userId);
				}
				else
					$allow_comment = $idea->email != "";
				?>
				<textarea id="vox_ideastatus_comment" name="vox_ideastatus_comment" class="vox_textarea" rows="4" <?if (!$allow_comment) {?> disabled <?}?> ></textarea>
				<br>
				<input type="checkbox" id="vox_ideastatus_sendupdate" name="vox_ideastatus_sendupdate" value="1" <?if (!$allow_comment) {?> disabled <?} else {?> checked <?}?>><span class="vox_form_field_title"><?=$VOX_MESSAGES["vox_msg_status_notifysubmitter"][$vox_language]?></span>
				<p>
				<a class="vox_action_link" href="javascript:void(0)" onclick="voxUI.closeStatusChangeForm(true);"><div class="vox_action_button"><?=$submitBtnTitle?></div></a>
			</div>
<?		
		}
	}
}

?>