CREATE DATABASE IF NOT EXISTS `VoxPopuli`;

USE `VoxPopuli`;

--
-- Table structure for table `Categories`
--

DROP TABLE IF EXISTS `Categories`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `Categories` (
  `Id` int(8) unsigned NOT NULL auto_increment,
  `Name` char(32) NOT NULL,
  `ForumId` tinytext,
  PRIMARY KEY  (`Id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
SET character_set_client = @saved_cs_client;

INSERT INTO `Categories` (
`Id` ,
`Name`,
`ForumId`
)
VALUES (
NULL , 'Default category', NULL
);

--
-- Table structure for table `Ideas`
--

DROP TABLE IF EXISTS `Ideas`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `Ideas` (
  `Id` int(8) unsigned NOT NULL auto_increment,
  `Category` tinyint(1) default NULL,
  `UserId` int(8) unsigned default NULL,
  `Name` tinytext,
  `EMail` tinytext,
  `ForumId` tinytext,
  `Status` tinyint(1) default '0',
  `DateAdded` date default NULL,
  `DateStatus` date default NULL,
  `Title` tinytext,
  `Description` text,
  `VotesFor` int(4) unsigned default '0',
  `VotesAgainst` int(4) unsigned default '0',
  PRIMARY KEY  (`Id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `Votes`
--

DROP TABLE IF EXISTS `Votes`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `Votes` (
  `UserId` int(8) unsigned NOT NULL,
  `IdeaId` int(8) unsigned NOT NULL,
  `Value` int(4) unsigned,
  `IP` int(8) default 0,
  `Random` int(8) default 0,
  KEY `COOKIE` (`IP`,`Random`,`IdeaId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `Log`
--

DROP TABLE IF EXISTS `Log`;
SET @saved_cs_client     = @@character_set_client;
SET character_set_client = utf8;
CREATE TABLE `Log` (
	`Id` int(8) unsigned NOT NULL auto_increment,
	`Time` date,
	`IdeaId` int(4),
	`EventType` int(4),
	`EventDetails` int(4),
	`UserId` int(8),
	PRIMARY KEY  (`Id`)
) ENGINE = MYISAM DEFAULT CHARSET=utf8;
SET character_set_client = @saved_cs_client;
